<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: FreeRTOS::Semaphore Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="classFreeRTOS.html">FreeRTOS</a></li><li class="navelem"><a class="el" href="classFreeRTOS_1_1Semaphore.html">Semaphore</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="classFreeRTOS_1_1Semaphore-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">FreeRTOS::Semaphore Class Reference</div>  </div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a0dbcd86df7fb789e05eee07f744df721"><td class="memItemLeft" align="right" valign="top"><a id="a0dbcd86df7fb789e05eee07f744df721"></a>
&#160;</td><td class="memItemRight" valign="bottom"><b>Semaphore</b> (std::string owner=&quot;&lt;Unknown&gt;&quot;)</td></tr>
<tr class="separator:a0dbcd86df7fb789e05eee07f744df721"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad1aa158e37d15363b4441482fae82dd8"><td class="memItemLeft" align="right" valign="top"><a id="ad1aa158e37d15363b4441482fae82dd8"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classFreeRTOS_1_1Semaphore.html#ad1aa158e37d15363b4441482fae82dd8">give</a> ()</td></tr>
<tr class="memdesc:ad1aa158e37d15363b4441482fae82dd8"><td class="mdescLeft">&#160;</td><td class="mdescRight">Give a semaphore. The <a class="el" href="classFreeRTOS_1_1Semaphore.html">Semaphore</a> is given. <br /></td></tr>
<tr class="separator:ad1aa158e37d15363b4441482fae82dd8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad6ad56219f257dada3ad820ebbe8ec12"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classFreeRTOS_1_1Semaphore.html#ad6ad56219f257dada3ad820ebbe8ec12">give</a> (uint32_t value)</td></tr>
<tr class="memdesc:ad6ad56219f257dada3ad820ebbe8ec12"><td class="mdescLeft">&#160;</td><td class="mdescRight">Give a semaphore. The <a class="el" href="classFreeRTOS_1_1Semaphore.html">Semaphore</a> is given with an associated value.  <a href="#ad6ad56219f257dada3ad820ebbe8ec12">More...</a><br /></td></tr>
<tr class="separator:ad6ad56219f257dada3ad820ebbe8ec12"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4446a195e3eee6704b4ad09528bedc0b"><td class="memItemLeft" align="right" valign="top"><a id="a4446a195e3eee6704b4ad09528bedc0b"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classFreeRTOS_1_1Semaphore.html#a4446a195e3eee6704b4ad09528bedc0b">giveFromISR</a> ()</td></tr>
<tr class="memdesc:a4446a195e3eee6704b4ad09528bedc0b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Give a semaphore from an ISR. <br /></td></tr>
<tr class="separator:a4446a195e3eee6704b4ad09528bedc0b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a24047020ab820d4f641bc39bfab643df"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classFreeRTOS_1_1Semaphore.html#a24047020ab820d4f641bc39bfab643df">setName</a> (std::string name)</td></tr>
<tr class="memdesc:a24047020ab820d4f641bc39bfab643df"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the name of the semaphore.  <a href="#a24047020ab820d4f641bc39bfab643df">More...</a><br /></td></tr>
<tr class="separator:a24047020ab820d4f641bc39bfab643df"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a67fa9bf777be48332a30154e006827fd"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classFreeRTOS_1_1Semaphore.html#a67fa9bf777be48332a30154e006827fd">take</a> (std::string owner=&quot;&lt;Unknown&gt;&quot;)</td></tr>
<tr class="memdesc:a67fa9bf777be48332a30154e006827fd"><td class="mdescLeft">&#160;</td><td class="mdescRight">Take a semaphore. Take a semaphore and wait indefinitely.  <a href="#a67fa9bf777be48332a30154e006827fd">More...</a><br /></td></tr>
<tr class="separator:a67fa9bf777be48332a30154e006827fd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a16aae1a6d6d09542d5af82f8b38fdd69"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classFreeRTOS_1_1Semaphore.html#a16aae1a6d6d09542d5af82f8b38fdd69">take</a> (uint32_t timeoutMs, std::string owner=&quot;&lt;Unknown&gt;&quot;)</td></tr>
<tr class="memdesc:a16aae1a6d6d09542d5af82f8b38fdd69"><td class="mdescLeft">&#160;</td><td class="mdescRight">Take a semaphore. Take a semaphore but return if we haven't obtained it in the given period of milliseconds.  <a href="#a16aae1a6d6d09542d5af82f8b38fdd69">More...</a><br /></td></tr>
<tr class="separator:a16aae1a6d6d09542d5af82f8b38fdd69"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a98e90c9cf596e4b214dd5a1c0ff745d7"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classFreeRTOS_1_1Semaphore.html#a98e90c9cf596e4b214dd5a1c0ff745d7">toString</a> ()</td></tr>
<tr class="memdesc:a98e90c9cf596e4b214dd5a1c0ff745d7"><td class="mdescLeft">&#160;</td><td class="mdescRight">Create a string representation of the semaphore.  <a href="#a98e90c9cf596e4b214dd5a1c0ff745d7">More...</a><br /></td></tr>
<tr class="separator:a98e90c9cf596e4b214dd5a1c0ff745d7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a023cb404ff897bb39064b454732ccf21"><td class="memItemLeft" align="right" valign="top">uint32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classFreeRTOS_1_1Semaphore.html#a023cb404ff897bb39064b454732ccf21">wait</a> (std::string owner=&quot;&lt;Unknown&gt;&quot;)</td></tr>
<tr class="memdesc:a023cb404ff897bb39064b454732ccf21"><td class="mdescLeft">&#160;</td><td class="mdescRight">Wait for a semaphore to be released by trying to take it and then releasing it again.  <a href="#a023cb404ff897bb39064b454732ccf21">More...</a><br /></td></tr>
<tr class="separator:a023cb404ff897bb39064b454732ccf21"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="ad6ad56219f257dada3ad820ebbe8ec12"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad6ad56219f257dada3ad820ebbe8ec12">&#9670;&nbsp;</a></span>give()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void FreeRTOS::Semaphore::give </td>
          <td>(</td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>value</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Give a semaphore. The <a class="el" href="classFreeRTOS_1_1Semaphore.html">Semaphore</a> is given with an associated value. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">value</td><td>The value to associate with the semaphore. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a24047020ab820d4f641bc39bfab643df"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a24047020ab820d4f641bc39bfab643df">&#9670;&nbsp;</a></span>setName()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void FreeRTOS::Semaphore::setName </td>
          <td>(</td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>name</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Set the name of the semaphore. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">name</td><td>The name of the semaphore. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a67fa9bf777be48332a30154e006827fd"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a67fa9bf777be48332a30154e006827fd">&#9670;&nbsp;</a></span>take() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool FreeRTOS::Semaphore::take </td>
          <td>(</td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>owner</em> = <code>&quot;&lt;Unknown&gt;&quot;</code></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Take a semaphore. Take a semaphore and wait indefinitely. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">owner</td><td>The new owner (for debugging) </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>True if we took the semaphore. </dd></dl>

</div>
</div>
<a id="a16aae1a6d6d09542d5af82f8b38fdd69"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a16aae1a6d6d09542d5af82f8b38fdd69">&#9670;&nbsp;</a></span>take() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool FreeRTOS::Semaphore::take </td>
          <td>(</td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>timeoutMs</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>owner</em> = <code>&quot;&lt;Unknown&gt;&quot;</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Take a semaphore. Take a semaphore but return if we haven't obtained it in the given period of milliseconds. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">timeoutMs</td><td>Timeout in milliseconds. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">owner</td><td>The new owner (for debugging) </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>True if we took the semaphore. </dd></dl>

</div>
</div>
<a id="a98e90c9cf596e4b214dd5a1c0ff745d7"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a98e90c9cf596e4b214dd5a1c0ff745d7">&#9670;&nbsp;</a></span>toString()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::string FreeRTOS::Semaphore::toString </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Create a string representation of the semaphore. </p>
<dl class="section return"><dt>Returns</dt><dd>A string representation of the semaphore. </dd></dl>

</div>
</div>
<a id="a023cb404ff897bb39064b454732ccf21"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a023cb404ff897bb39064b454732ccf21">&#9670;&nbsp;</a></span>wait()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">uint32_t FreeRTOS::Semaphore::wait </td>
          <td>(</td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>owner</em> = <code>&quot;&lt;Unknown&gt;&quot;</code></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Wait for a semaphore to be released by trying to take it and then releasing it again. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">owner</td><td>A debug tag. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The value associated with the semaphore. </dd></dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li><a class="el" href="FreeRTOS_8h_source.html">FreeRTOS.h</a></li>
<li>FreeRTOS.cpp</li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
